﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="TestHandleBars.Default" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title></title>
    <style type="text/css">
        .GridViewHeader {
            background-color:#888;
        }

        .GridViewRow0 {
            background-color:#ddd;
        }
        .GridViewRow1 {
            background-color:#fff;
        }
        .GridViewRowFooter {
            background-color:#0ff;
        }
        .GridViewCellAlignCenter {
            text-align:center;
        }
    </style>
    <script type="text/javascript" src="/Scripts/jquery-1.8.2.min.js"></script>
    <script type="text/javascript" src="/Scripts/handlebars-v1.3.0.js"></script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <div id="div1"></div>
    </div>
    </form>

<script>

    /* using logical */
    Handlebars.registerHelper('iif', function (index, options) {

        if ((index % 2) == 0) {
            return options.fn(this);
        }
        else {
            return options.inverse(this);
        }
    });

    Handlebars.registerHelper('sum', function (price, sales) {
        return price * sales;
    });

    Handlebars.registerHelper('total', function (array, key) {
        var total = 0;
        array.forEach(function (o) {
            total += (o[key]);
        });
        return total;
    });

    Handlebars.registerHelper('totalPrice', function (array, price, sales) {
        var total = 0;
        array.forEach(function (o) {
            total += (o[price] * o[sales]);
        });
        return total;
    });


</script>

<script id="summary-result-template" type="text/x-handlebars-template">
<table class="GridView" cellspacing="0" border="0" id="ctl00_ContentPlaceHolder1_gvResult" style="width:100%;border-collapse:collapse;">
    <tbody>
        <tr class="GridViewHeader">
            <th class="GridViewCellAlignCenter" scope="col">Item</th>
            <th class="GridViewCellAlignCenter" scope="col">Price</th>
            <th class="GridViewCellAlignCenter" scope="col">Sales</th>
            <th class="GridViewCellAlignCenter" scope="col">Total Price</th>
        </tr>
    {{#each this}}
        {{#iif @index}}
         <tr class="GridViewRow0">
        {{else}}
         <tr class="GridViewRow1">
        {{/iif}}
		    <td class="GridViewCellAlignCenter">{{item}}</td>
            <td class="GridViewCellAlignCenter">{{price}}</td>
            <td class="GridViewCellAlignCenter">{{amount}}</td>
            <td class="GridViewCellAlignCenter">{{sum price amount}}</td>
        </tr>
    {{/each}}
        <tr class="GridViewRowFooter">
            <td class="GridViewCellAlignCenter">Total</td>
            <td class="GridViewCellAlignCenter">&nbsp;</td>
            <td class="GridViewCellAlignCenter">{{total this "amount"}}</td>
            <td class="GridViewCellAlignCenter">{{totalPrice this "price" "amount"}}</td>
        </tr>
    </tbody>
</table>
</script>
<script>
    var source = $("#summary-result-template").html();
    var template = Handlebars.compile(source);

    var jsondata = [{ "item": "apple", "price": 100, "amount": 500 }, { "item": "orange", "price": 50, "amount": 100 }, { "item": "grape", "price": 200, "amount": 90 }];

    $("#div1").append(template(jsondata));

</script>
</body>
</html>
